# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'AppAuthorizationCredentialArgs',
    'AppAuthorizationCredentialArgsDict',
    'AppAuthorizationCredentialApiKeyCredentialArgs',
    'AppAuthorizationCredentialApiKeyCredentialArgsDict',
    'AppAuthorizationCredentialOauth2CredentialArgs',
    'AppAuthorizationCredentialOauth2CredentialArgsDict',
    'AppAuthorizationTenantArgs',
    'AppAuthorizationTenantArgsDict',
    'AppAuthorizationTimeoutsArgs',
    'AppAuthorizationTimeoutsArgsDict',
]

MYPY = False

if not MYPY:
    class AppAuthorizationCredentialArgsDict(TypedDict):
        api_key_credentials: NotRequired[pulumi.Input[Sequence[pulumi.Input['AppAuthorizationCredentialApiKeyCredentialArgsDict']]]]
        """
        Contains API key credential information.
        """
        oauth2_credential: NotRequired[pulumi.Input['AppAuthorizationCredentialOauth2CredentialArgsDict']]
        """
        Contains OAuth2 client credential information.
        """
elif False:
    AppAuthorizationCredentialArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AppAuthorizationCredentialArgs:
    def __init__(__self__, *,
                 api_key_credentials: Optional[pulumi.Input[Sequence[pulumi.Input['AppAuthorizationCredentialApiKeyCredentialArgs']]]] = None,
                 oauth2_credential: Optional[pulumi.Input['AppAuthorizationCredentialOauth2CredentialArgs']] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input['AppAuthorizationCredentialApiKeyCredentialArgs']]] api_key_credentials: Contains API key credential information.
        :param pulumi.Input['AppAuthorizationCredentialOauth2CredentialArgs'] oauth2_credential: Contains OAuth2 client credential information.
        """
        if api_key_credentials is not None:
            pulumi.set(__self__, "api_key_credentials", api_key_credentials)
        if oauth2_credential is not None:
            pulumi.set(__self__, "oauth2_credential", oauth2_credential)

    @property
    @pulumi.getter(name="apiKeyCredentials")
    def api_key_credentials(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AppAuthorizationCredentialApiKeyCredentialArgs']]]]:
        """
        Contains API key credential information.
        """
        return pulumi.get(self, "api_key_credentials")

    @api_key_credentials.setter
    def api_key_credentials(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AppAuthorizationCredentialApiKeyCredentialArgs']]]]):
        pulumi.set(self, "api_key_credentials", value)

    @property
    @pulumi.getter(name="oauth2Credential")
    def oauth2_credential(self) -> Optional[pulumi.Input['AppAuthorizationCredentialOauth2CredentialArgs']]:
        """
        Contains OAuth2 client credential information.
        """
        return pulumi.get(self, "oauth2_credential")

    @oauth2_credential.setter
    def oauth2_credential(self, value: Optional[pulumi.Input['AppAuthorizationCredentialOauth2CredentialArgs']]):
        pulumi.set(self, "oauth2_credential", value)


if not MYPY:
    class AppAuthorizationCredentialApiKeyCredentialArgsDict(TypedDict):
        api_key: pulumi.Input[str]
        """
        Contains API key credential information.
        """
elif False:
    AppAuthorizationCredentialApiKeyCredentialArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AppAuthorizationCredentialApiKeyCredentialArgs:
    def __init__(__self__, *,
                 api_key: pulumi.Input[str]):
        """
        :param pulumi.Input[str] api_key: Contains API key credential information.
        """
        pulumi.set(__self__, "api_key", api_key)

    @property
    @pulumi.getter(name="apiKey")
    def api_key(self) -> pulumi.Input[str]:
        """
        Contains API key credential information.
        """
        return pulumi.get(self, "api_key")

    @api_key.setter
    def api_key(self, value: pulumi.Input[str]):
        pulumi.set(self, "api_key", value)


if not MYPY:
    class AppAuthorizationCredentialOauth2CredentialArgsDict(TypedDict):
        client_id: pulumi.Input[str]
        """
        The client ID of the client application.
        """
        client_secret: pulumi.Input[str]
        """
        The client secret of the client application.
        """
elif False:
    AppAuthorizationCredentialOauth2CredentialArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AppAuthorizationCredentialOauth2CredentialArgs:
    def __init__(__self__, *,
                 client_id: pulumi.Input[str],
                 client_secret: pulumi.Input[str]):
        """
        :param pulumi.Input[str] client_id: The client ID of the client application.
        :param pulumi.Input[str] client_secret: The client secret of the client application.
        """
        pulumi.set(__self__, "client_id", client_id)
        pulumi.set(__self__, "client_secret", client_secret)

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> pulumi.Input[str]:
        """
        The client ID of the client application.
        """
        return pulumi.get(self, "client_id")

    @client_id.setter
    def client_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "client_id", value)

    @property
    @pulumi.getter(name="clientSecret")
    def client_secret(self) -> pulumi.Input[str]:
        """
        The client secret of the client application.
        """
        return pulumi.get(self, "client_secret")

    @client_secret.setter
    def client_secret(self, value: pulumi.Input[str]):
        pulumi.set(self, "client_secret", value)


if not MYPY:
    class AppAuthorizationTenantArgsDict(TypedDict):
        tenant_display_name: pulumi.Input[str]
        """
        The display name of the tenant.
        """
        tenant_identifier: pulumi.Input[str]
        """
        The ID of the application tenant.
        """
elif False:
    AppAuthorizationTenantArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AppAuthorizationTenantArgs:
    def __init__(__self__, *,
                 tenant_display_name: pulumi.Input[str],
                 tenant_identifier: pulumi.Input[str]):
        """
        :param pulumi.Input[str] tenant_display_name: The display name of the tenant.
        :param pulumi.Input[str] tenant_identifier: The ID of the application tenant.
        """
        pulumi.set(__self__, "tenant_display_name", tenant_display_name)
        pulumi.set(__self__, "tenant_identifier", tenant_identifier)

    @property
    @pulumi.getter(name="tenantDisplayName")
    def tenant_display_name(self) -> pulumi.Input[str]:
        """
        The display name of the tenant.
        """
        return pulumi.get(self, "tenant_display_name")

    @tenant_display_name.setter
    def tenant_display_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "tenant_display_name", value)

    @property
    @pulumi.getter(name="tenantIdentifier")
    def tenant_identifier(self) -> pulumi.Input[str]:
        """
        The ID of the application tenant.
        """
        return pulumi.get(self, "tenant_identifier")

    @tenant_identifier.setter
    def tenant_identifier(self, value: pulumi.Input[str]):
        pulumi.set(self, "tenant_identifier", value)


if not MYPY:
    class AppAuthorizationTimeoutsArgsDict(TypedDict):
        create: NotRequired[pulumi.Input[str]]
        """
        A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours).
        """
        delete: NotRequired[pulumi.Input[str]]
        """
        A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours). Setting a timeout for a Delete operation is only applicable if changes are saved into state before the destroy operation occurs.
        """
        update: NotRequired[pulumi.Input[str]]
        """
        A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours).
        """
elif False:
    AppAuthorizationTimeoutsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AppAuthorizationTimeoutsArgs:
    def __init__(__self__, *,
                 create: Optional[pulumi.Input[str]] = None,
                 delete: Optional[pulumi.Input[str]] = None,
                 update: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] create: A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours).
        :param pulumi.Input[str] delete: A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours). Setting a timeout for a Delete operation is only applicable if changes are saved into state before the destroy operation occurs.
        :param pulumi.Input[str] update: A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours).
        """
        if create is not None:
            pulumi.set(__self__, "create", create)
        if delete is not None:
            pulumi.set(__self__, "delete", delete)
        if update is not None:
            pulumi.set(__self__, "update", update)

    @property
    @pulumi.getter
    def create(self) -> Optional[pulumi.Input[str]]:
        """
        A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours).
        """
        return pulumi.get(self, "create")

    @create.setter
    def create(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create", value)

    @property
    @pulumi.getter
    def delete(self) -> Optional[pulumi.Input[str]]:
        """
        A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours). Setting a timeout for a Delete operation is only applicable if changes are saved into state before the destroy operation occurs.
        """
        return pulumi.get(self, "delete")

    @delete.setter
    def delete(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delete", value)

    @property
    @pulumi.getter
    def update(self) -> Optional[pulumi.Input[str]]:
        """
        A string that can be [parsed as a duration](https://pkg.go.dev/time#ParseDuration) consisting of numbers and unit suffixes, such as "30s" or "2h45m". Valid time units are "s" (seconds), "m" (minutes), "h" (hours).
        """
        return pulumi.get(self, "update")

    @update.setter
    def update(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "update", value)


